/* mykbd.c : Ver. 0.3 */
/* Copyright (C) K.Yoshizawa 1996 */

/*==========================================================================

ΉRpC

̃vÓAꕔāA ANSI-C ŏĂ܂B

ANSI-CɂĂȂ̂́Awꕶ́A^[x̂߂ getch() 
łB̕C΁Aǂ̂悤 ANSI-C Ή̃RpCłgp\
Ǝv܂B

R[fBO X^C

1 TAB = 4 SPACE 肵Ă܂Bmain() ̓t@C̍ŌɒuĂ܂B

蕳ȓ_

قǔėpȂ̂ŁAuߑłv܂Ă܂B



Ver.	DATE		COMMENT
0.3		1996/01/05	ŏ̌Jo[W

============================================================================*/

/****************************************************************************/
/*	t@C													*/
/****************************************************************************/

/* ANSI-C Wwb_[ t@C */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Borland C ŗL̃wb_[ t@C */
#include <conio.h>	/* for getch() */

/****************************************************************************/
/*	ʒ`																*/
/****************************************************************************/

typedef unsigned char BYTE;
typedef unsigned short WORD;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* IBMKBD.SYS ǂݍނ߂̃obt@̑傫 */
#define KBD_BUF_SIZE 0x4000

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* XLR[hւ̍ő */
#define MAX_N_SWAP	256

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* pb` [`̍ő咷 */
/* I[o[t[̓`FbNĂȂ̂ŁA\傫mۂ邱 */
#define MAX_PATCH_SIZE	1024

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* NEW EXE wb_փANZX邽߂̃}N */
/* rł߂ǂɂȂ̂ŁAS͍ĂȂ */
#define SEG_TBL_OFS(BUF)	(*(WORD*)&(BUF)[0x80+0x22]+0x80)
#define SEG_TBL_CNT(BUF)	(*(WORD*)&(BUF)[0x80+0x1c])
#define SECT_SIZE(BUF)		(1<<(*(WORD*)&(BUF)[0x80+0x32]))

#define SEG_OFS(BUF,N) 		(*(WORD*)&(BUF)[SEG_TBL_OFS(BUF)+(N)*8]*\
							SECT_SIZE(BUF))
#define SEG_FILE(BUF,N)		(*(WORD*)&(BUF)[SEG_TBL_OFS(BUF)+(N)*8+2])
#define SEG_FLAG(BUF,N)		(*(WORD*)&(BUF)[SEG_TBL_OFS(BUF)+(N)*8+4])
#define SEG_ALLOC(BUF,N)	(*(WORD*)&(BUF)[SEG_TBL_OFS(BUF)+(N)*8+6])

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

#define PRINTF if(verbose) printf
#define FFLUSH if(verbose) fflush

/****************************************************************************/
/*	O[oϐQ														*/
/****************************************************************************/

static int verbose = 0;		/* DEBUG  1 ɂƊe탁bZ[Wo */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* IBMKBD.SYS & MYKBD.SYS ̂߂̃obt@ */
static BYTE kbd_buf[KBD_BUF_SIZE];
static int org_size;
static int new_size;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* DATA / CODE ZOg̃ZOgNo. */
static int data_seg, code_seg;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* I/O port 60H f[^ǂݍł镔̃}Ṽp^[B */
static WORD in_60_pat[] = {
	0xe4, 0x60,			/* in al,60h		*/
	0x88, 0x46, 0xfe,	/* mov [bp-2], al	*/
};

/* pb`Ăꏊ */
#define IN_60_PAT_OFS	2

/* ̃p[^̂AhX(-1͖Ӗ) */
static in_60_ofs = -1;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* foCX hCo ɑ΂ init ߂̍ŌŁAR[h ZOgƃf[^ */
/* ZOg̐؂藣AhXZbgĂ镔̃}Ṽp^[B */
/* 0xffff ́A 1 oCg̒lsł邱ƂB */
static WORD limit_addr_pat[] =
{
	0xc4, 0x5e, 0xfc,		/* les bx,ss:[-04+bp] */
    0x26, 0xc7, 0x47, 0x0e,	/* mov word ptr es:[bx+0eh], NNNN */
	0xffff, 0xffff,
    0x26, 0xc7, 0x47, 0x10,	/* mov word ptr es:[bx+10h], NNNN */
	0xffff, 0xffff,
};

/*  NNNN ̊eoCgʒu */
#define CODE_LIMIT_LO	7
#define CODE_LIMIT_HI	8
#define DATA_LIMIT_LO	13
#define DATA_LIMIT_HI	14

/* ̃p[^̂AhX(-1͖Ӗ) */
static limit_addr_ofs = -1;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* XLR[hւe[u */

static BYTE swap_table[MAX_N_SWAP][2];
static int n_swap;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* pb` [`̈ꎞu */
static BYTE patch_buf[MAX_PATCH_SIZE];
static int patch_size;

/****************************************************************************/
/*	^CgAgp@Ȃ[UC^[tF[Xn̊֐Q				*/
/****************************************************************************/

static
void title(void)
{
	printf(
"\n"
"mykbd : Keyboard Layout Configuration Utility (Ver. 0.3)\n"
"Copyright (C) K.Yoshizawa 1996\n"
"\n"
"--- This utility must be run under DOS/V window ---\n"
"\n"
	);
}

static
void pause(void)
{
	printf(
"    ܂ByEnter()zĂB(yESCzŒf)\n"
	);
	for (;;) {
		switch (getch()) {
		case 0x0d:			/* CR */
		case 0x0a:			/* NL(LF) */
			return;
		case 0x1b:			/* ESC */
		case 0x03:			/* CTRL-C */
			exit(1);
			break;			/* dummy break */
		}
	}
}

static
void usage(void)
{
	printf(
"\n"
"Tv\n"
"  OS/2 Warp ̃L[{[h hCo IBMKBD.SYS ́EύXāA\n"
"\n"
"    yCTRLz<->yCapsLockzAyESCz<->yp/Spz\n"
"\n"
"  Ȃǂ̃L[̓ւ@\ MYKBD.SYS 𐶐܂B\n"
"\n"
"  OADG 106 {L[{[hΏۂłÃL[{[h(Ⴆ 101 pL[\n"
"  {[h)Ȃǂł삷ł傤B\n"
"\n"
	);
	pause();
	printf(
"\n"
"ۏ\n"
"  ̃\tgEFA͖ۏ؂łB̃\tgEFAɂĂȂ鎖Ԃ\n"
"  悤ƂA͂֒m܂B܂łAȂ̐ӔCƊ댯\n"
"  ŜƂɎgpĂB܂Ã\tgEFAɊւT|[gA\n"
"  ɑ΂񓚂ȂǂsƂA񑩂ł܂B\n"
"  ȏ̎ɓӂłȂꍇ́Ã\tgEFA̎gp𒆎~Ă\n"
"  B\n"
"\n"
"Ĕzz\n"
"  ̃\tgEFA̓t[\tgEFAłBzzt@CɕύXȂ\n"
"  ARɍĔzzĂ܂܂B\n"
"  ύXꍇ́AύX̓eƕύX҂肷ɏ\ȏYt\n"
"  Ȃ΁AɎ̋𓾂ƂARɍĔzzĂ܂܂B(̃[\n"
"  eBeB̔\͂Ή͈͂L邽߂̕ύX́A劽}łB)\n"
"  ȊǑ`Ԃ̍Ĕzz͋֎~܂B\n"
"\n"
	);
	pause();
	printf(
"\n"
"g\n"
"(1)  MYKBD.SYS gpĂꍇ́A CONFIG.SYS ɖ߂\n"
"    ċNĂB(gpĂȂ΁AKv͂܂B)\n"
"\n"
"(2) OS/2 Warp  CD-ROMA܂́Atbs[(IBMKBD.SYS Ă)\n"
"    ZbgāÂ悤Ƀ^CvĂB\n"
"\n"
"      C>MYKBD  OS/2̃fBNg  IBMKBD.SYŜ肩  ύXf[^t@C\n"
"\n"
"      OS/2̃fBNg\n"
"        OS/2 Warp CXg[fBNgw肵܂B\n"
"      IBMKBD.SYŜ肩\n"
"        CD-ROM ܂̓tbs[̒ IBMKBD.SYS ւ̃pXw肵܂B\n"
"      ύXf[^t@C\n"
"        ǂ̃L[ւ̂Lqt@Cw肵܂B炩\n"
"        ߗpӂĂ̂́A̓łB\n"
"          ECTRL.DAT    :yCTRLz<->yCapsLockz\n"
"          EESC.DAT     :yESCz<->yp/Spz\n"
"        ̃t@Cgݍ킹Ďw肷邱Ƃł܂B\n"
"\n"
	);
	pause();
	printf(
"\n"
"(3) OS/2 ̃fBNg̉̃TufBNg BOOT ɁAL[ւp\n"
"    ύXꂽVL[{[h hCo MYKBD.SYS 쐬͂łB\n"
"    CONFIG.SYS Ŏ̂悤ȍsTA\n"
"\n"
"      BASEDEV=IBMKBD.SYS\n"
"\n"
"    ̂悤ɕύXĂB\n"
"\n"
"      BASEDEV=MYKBD.SYS\n"
"\n"
"    āAOS/2 n[hfBXNċNĂBŃL[\n"
"    ւ͂łB\n"
"\n"
"(4) ܂Ȃꍇ́AOS/2 tbs[NāAōs\n"
"     CONFIG.SYS ̕ύXɖ߂ĂBNp̃tbs[ƂẮA\n"
"   u[eBeB fBXPbgvƂč쐬tbs[g܂B\n"
"    Oɍ쐬ĂƂA߂܂B\n"
"\n"
	);
	pause();
	printf(
"\n"
"\n"
"(1) L[ւ̌ʂ́AVXeŜɂт܂BāAwl\n"
"    ň̃}VpĂ̂ŁAlɂēւLZ\n"
"    xȂǂƌĂA͂ł܂B\n"
"\n"
"(2) OS/2 Warp  Ver.3.00  3.01 œmFĂ܂BAȊO\n"
"    ̔ł OS/2 ł܂ۏ؂͂܂BAw͎sx܂\n"
"    wύXsx̃G[bZ[WoĂ܂AvO(MYKBD.C)\n"
"    C邩AꂪłȂ́A߂ĂB\n"
"\n"
"\n"
"  ̗ł́AC:\\OS2  OS/2 Warp CX[gfBNgAE:h\n"
"  Cu CD-ROM ŁAyCTRLz<->yCapsLockzAyESCz<->yp/Spz\n"
"  oւĂ܂B\n"
"\n"
"     C>MYKBD C:\\OS2 E:\\OS2IMAGE\\DISK_1\\IBMKBD.SYS CTRL.DAT ESC.DAT\n"
"\n"
	);
}

/****************************************************************************/
/*	t@Co͊֐Q													*/
/****************************************************************************/

static
long load_binary_file(char *fname, BYTE *buf, int buf_size)
{
	long s;
	FILE *fp;

	printf("t@C '%s' ǂݍݒ ... ", fname);
	fflush(stdout);

	if ((fp = fopen(fname, "rb")) == NULL) {
		printf("t@CI[vł܂\n");
		perror(fname);
		return 0;
	}

	s = fread(buf, 1, buf_size, fp);
	if (s <= 0) {
		printf("t@Cf[^ǂ߂܂\n");
		perror(fname);
		fclose(fp);
		return 0;
	}

	if ( ! feof(fp)) {
		printf("t@C傫܂\n");
		return 0;
	}

	fclose(fp);

	printf("OK (size = 0x%04lx(%ld) byte)\n", s, s);

	return s;
}

static
long save_binary_file(char *fname, BYTE *buf, int data_size)
{
	long s;
	FILE *fp;

	printf("t@C '%s' ݒ ... ", fname);
	fflush(stdout);

	if ((fp = fopen(fname, "wb")) == NULL) {
		printf("t@CI[vł܂\n");
		perror(fname);
		return 0;
	}

	s = fwrite(buf, 1, data_size, fp);
	if (s != data_size) {
		printf("t@CɃf[^߂܂\n");
		perror(fname);
		fclose(fp);
		return 0;
	}

	fclose(fp);

	printf("OK (size = 0x%04lx(%ld) byte)\n", s, s);

	return s;
}

static
int load_swap_info_file(char *fname)
{
	FILE *fp;
	char buf[256];
	long lcount;

	printf("ύXf[^ t@C '%s' ǂݍݒ ... ", fname);
	fflush(stdout);

	if ((fp = fopen(fname, "rt")) == NULL) {
		printf("t@CI[vł܂\n");
		perror(fname);
		return 0;
	}

	lcount = 0;

	PRINTF("\n");

	while (fgets(buf, sizeof(buf), fp) != NULL) {
		char ch;
		int b1, b2;

		lcount++;
		if (sscanf(buf, "%1s", &ch) == 0 || ch == '#') continue;
		if (sscanf(buf, "%x%x", &b1, &b2) != 2
		|| b1 < 0 || b1 > 0xff || b2 < 0 || b2 > 0xff) {
			printf(
"%s:%lds:G[(ւ scan code ̎w肪s)\n"
			, fname, lcount);
			fclose(fp);
			return 0;
		}
		if (++n_swap >= MAX_N_SWAP) {
			printf(
"%s:%lds:ւL[̌܂(XL R[hōő %d )\n"
			, fname, lcount, MAX_N_SWAP);
			fclose(fp);
			return 0;
		}
		swap_table[n_swap-1][0] = b1;
		swap_table[n_swap-1][1] = b2;
		PRINTF("  %02x -> %02x\n"
		, swap_table[n_swap-1][0] , swap_table[n_swap-1][1]);
	}

	fclose(fp);

	printf("OK\n");

	return 1;
}

/****************************************************************************/
/*	foCXhCo͊֐Q												*/
/****************************************************************************/

/* buf (buf_sizeoCg)̒ buf[base] ȍ~ pat (pat_sizeoCg)T */
/* āÂ肩ԂB*/
static
int search_pat(BYTE *buf, int buf_size, int base, WORD *pat, int pat_size)
{
	int i, j;

	for (i = base; i < buf_size - pat_size; i++) {
		for (j = 0; j < pat_size; j++) {
			if ((pat[j] & 0xff00) != 0) continue;
			if (buf[i + j] != pat[j]) break;
		}
		if (j == pat_size) return i;
	}
	return -1;
}

static
int analysis(void)
{
	int i;
	int n_segs;
	int seg_flag;
	int pos;

	if ((n_segs = SEG_TBL_CNT(kbd_buf)) != 2) {
		printf(
"ZOǧ %d łB\n"
"ZOǧ 2 ł邱Ƃ肵Ă܂B\n"
		, n_segs);
		return 0;
	}

	data_seg = code_seg = -1;
	for (i = 0; i < n_segs; i++) {
		PRINTF("SEGMENT #%04x\n", i);
		seg_flag = SEG_FLAG(kbd_buf, i);
		PRINTF("  FLAG       : %04x", seg_flag);
		if ((seg_flag & 0x0007) == 0x0000) {
			PRINTF(" CODE");
			code_seg = i;
		}
		if ((seg_flag & 0x0007) == 0x0001) {
			PRINTF(" DATA");
			data_seg = i;
		}
		PRINTF("\n");
		PRINTF("  OFFSET     : %04x\n", SEG_OFS(kbd_buf, i));
		PRINTF("  FILE SIZE  : %04x\n", SEG_FILE(kbd_buf, i));
		PRINTF("  ALLOC SIZE : %04x\n", SEG_ALLOC(kbd_buf, i));
	}
	if (data_seg != 0 || code_seg != 1) {
		printf(
"ZOg̏ɕł邱Ƃ肵Ă܂AȂĂ܂B\n"
"  #0000 DATA ZOg\n"
"  #0001 CODE ZOg\n"
		);
		return 0;
	}

	PRINTF("I/O port ͕T ...");
	FFLUSH(stdout);
	for (
		pos = 0;
		(pos = search_pat(kbd_buf, org_size, pos, in_60_pat
							, sizeof(in_60_pat)/sizeof(in_60_pat[0]) )) >= 0;
		pos++
	) {
		PRINTF(" (0x%04x)", pos);
		FFLUSH(stdout);
		if (in_60_ofs < 0) {
			in_60_ofs = pos;
		} else {
			PRINTF(
" I/O port ͕邽߁AǂύXĂ悢̂܂B\n"
			);
			return 0;
		}
	}
	if (in_60_ofs < 0) {
		PRINTF("Ts\n");
		return 0;
	}
	PRINTF(" ... OK\n");

	PRINTF("ZOg؂藣AhXݒ蕔T ...");
	FFLUSH(stdout);
	for (
		pos = 0;
		(pos = search_pat(kbd_buf, org_size, pos, limit_addr_pat
					, sizeof(limit_addr_pat)/sizeof(limit_addr_pat[0]) )) >= 0;
		pos++
	) {
		if (kbd_buf[pos + CODE_LIMIT_HI] >= 0x0d
		&&  kbd_buf[pos + CODE_LIMIT_HI] <= 0x10
		) {
			PRINTF("(0x%04x)", pos);
			FFLUSH(stdout);
			if (limit_addr_ofs < 0) {
				limit_addr_ofs = pos;
			} else {
				printf(
"̃ZOgݒ蕔炵R[h邽߁AǂύXĂ悢̂\n"
"܂B\n"
				);
				return 0;
			}
		}
	}
	if (limit_addr_ofs < 0) {
		PRINTF("Ts\n");
		return 0;
	}
	PRINTF(" ... OK\n");
	PRINTF("  mov word ptr es:[bx+0eh], %02x%02xh\n"
	, kbd_buf[limit_addr_ofs + CODE_LIMIT_HI]
	, kbd_buf[limit_addr_ofs + CODE_LIMIT_LO]);
	PRINTF("  mov word ptr es:[bx+10h], %02x%02xh\n"
	, kbd_buf[limit_addr_ofs + DATA_LIMIT_HI]
	, kbd_buf[limit_addr_ofs + DATA_LIMIT_LO]);

	return 1;
}

/****************************************************************************/
/*	foCXhCoύX(pb`)֐Q									*/
/****************************************************************************/

static
int generate(void)
{
	WORD SaveE0;
	WORD patch_entry_ofs;
	WORD new_code_seg_size;

	/* ̑ÕR[h E0 ǂoĂ߂̕ϐp */
	{
		SaveE0 = SEG_ALLOC(kbd_buf, data_seg);
		SEG_ALLOC(kbd_buf, data_seg) += 2;
		PRINTF("XL R[hҔϐAhX = 0x%04x\n", SaveE0);

		PRINTF("DATA ZOg؂藣AhX 0x%04x ->"
			, *(WORD*)&kbd_buf[limit_addr_ofs + DATA_LIMIT_LO]);
		*(WORD*)&kbd_buf[limit_addr_ofs + DATA_LIMIT_LO]
			= SEG_ALLOC(kbd_buf, data_seg);
		PRINTF("0x%04x\n"
			, *(WORD*)&kbd_buf[limit_addr_ofs + DATA_LIMIT_LO]);
	}

	/* pb` [`pӂB*/
	{
		int addr;	/* ZOgAhX(t@CItZbgƂ͈قȂ) */
		WORD label1;
		WORD ofs;
		int i;

		addr = 0;

		label1 = 12 + n_swap * 9;

		patch_entry_ofs
			= SEG_FILE(kbd_buf, code_seg) + SEG_OFS(kbd_buf, code_seg);

		/* ÕXL R[h E0 Ȃ猻݂̃XL R[hfʂ */
		/* 邽߂̃[` (12 byte) */
		patch_buf[addr++] = 0x50;	/* push ax */
		patch_buf[addr++] = 0xa0;	/* mov al, [SaveE0] */
		patch_buf[addr++] = SaveE0;
		patch_buf[addr++] = SaveE0 >> 8;
		patch_buf[addr++] = 0x3c;	/* cmp al, E0H */
		patch_buf[addr++] = 0xe0;
		patch_buf[addr++] = 0x58;	/* pop ax */
		patch_buf[addr++] = 0x75;	/* jne +3*/
		patch_buf[addr++] = 0x03;
		ofs = label1 - (addr + 3);
		patch_buf[addr++] = 0xe9;	/* jmp label1*/
		patch_buf[addr++] = ofs;
		patch_buf[addr++] = ofs >> 8;

		/* eXL R[h̓ւ[` (9 byte)*/
		for (i=0; i<n_swap; i++) {
			patch_buf[addr++] = 0x3c;	/* cmp al,imm(original scan code) */
			patch_buf[addr++] = swap_table[i][0];
			patch_buf[addr++] = 0x75;	/* jne +5 */
			patch_buf[addr++] = 0x05;
			patch_buf[addr++] = 0xb0;	/* mov al,imm(new scan code) */
			patch_buf[addr++] = swap_table[i][1];
			ofs = label1 - (addr + 3);
			patch_buf[addr++] = 0xe9;	/* jmp label1*/
			patch_buf[addr++] = ofs;
			patch_buf[addr++] = ofs >> 8;
		}

/*  label1 ̈ʒuɑ */

		/* n[` (9 byte) */
		patch_buf[addr++] = 0xa2;	/* mov [SaveE0], al */
		patch_buf[addr++] = SaveE0;
		patch_buf[addr++] = SaveE0 >> 8;

		patch_buf[addr++] = kbd_buf[in_60_ofs + IN_60_PAT_OFS];
		patch_buf[addr++] = kbd_buf[in_60_ofs + IN_60_PAT_OFS + 1];
		patch_buf[addr++] = kbd_buf[in_60_ofs + IN_60_PAT_OFS + 2];

		ofs = (in_60_ofs + IN_60_PAT_OFS + 3) - (patch_entry_ofs + addr + 3);
		patch_buf[addr++] = 0xe9;	/* jmp */
		patch_buf[addr++] = ofs;
		patch_buf[addr++] = ofs >> 8;

		while (addr % 2 != 0) patch_buf[addr++] = 0x90;	/* nop */

		patch_size = addr;

		PRINTF("pb` [` TCY : 0x%04x(%d) byte\n"
			, patch_size, patch_size);
	}

	/* Vt@C TCY */
	new_size = org_size + patch_size;
	PRINTF("t@C TCY : 0x%04x(%d) byte -> 0x%04x(%d) byte\n"
			, org_size, org_size, new_size, new_size);

	/* OLD EXE HEADER C */
	{
		WORD page_size;

		page_size = (new_size + 511) / 512;

		*(WORD*)&kbd_buf[2] = new_size % 512;
		*(WORD*)&kbd_buf[4] = page_size;
		PRINTF("OLD-EXE / BYTE IN LAST PAGE = 0x%04x\n", *(WORD*)&kbd_buf[2]);
		PRINTF("OLD-EXE / NUM OF PAGE = 0x%04x\n", *(WORD*)&kbd_buf[4]);
	}

	/* P[Vړ */
	/* pb` [`ړ */
	/* R[h ZOg؂藣AhX̏C */
	{
		WORD rel_pos0;
		WORD rel_pos1;
		WORD rel_size;

		rel_pos0 = patch_entry_ofs;
		rel_size = 2 + *(WORD*)&kbd_buf[rel_pos0] * 8;
		rel_pos1 = rel_pos0 + patch_size;

		memmove(&kbd_buf[rel_pos1], &kbd_buf[rel_pos0], patch_size);

		PRINTF("P[Vړ : 0x%04x -> 0x%04x (0x%04x(%d) byte)\n"
			, rel_pos0, rel_pos1, rel_size, rel_size);

		memmove(&kbd_buf[rel_pos0], patch_buf, patch_size);

		PRINTF("pb` [`gݍ : -> 0x%04x\n", in_60_ofs);

		new_code_seg_size
			= SEG_FILE(kbd_buf, code_seg) + patch_size;

		PRINTF("CODE ZOg؂藣AhX 0x%04x ->"
			, *(WORD*)&kbd_buf[limit_addr_ofs + CODE_LIMIT_LO]);
		*(WORD*)&kbd_buf[limit_addr_ofs + CODE_LIMIT_LO]
			= new_code_seg_size;
		PRINTF("0x%04x\n"
			, *(WORD*)&kbd_buf[limit_addr_ofs + CODE_LIMIT_LO]);
	}

	/* NEW EXE HEADER C */
	{
		SEG_FILE(kbd_buf, code_seg) = new_code_seg_size;
		SEG_ALLOC(kbd_buf, code_seg) = ((new_code_seg_size + 3) / 4) * 4;
		PRINTF("NEW-EXE CODE FILE SIZE = 0x%04x\n"
			, SEG_FILE(kbd_buf, code_seg));
		PRINTF("NEW-EXE CODE ALLOC SIZE = 0x%04x\n"
			, SEG_ALLOC(kbd_buf, code_seg));
	}

	/* pb` [`ւ̃Wvߖߍ */
	{
		WORD ofs;

		ofs = patch_entry_ofs - (in_60_ofs + IN_60_PAT_OFS + 3);

		kbd_buf[in_60_ofs + IN_60_PAT_OFS] = 0xe9;	/* jmp ofs16 */
		kbd_buf[in_60_ofs + IN_60_PAT_OFS + 1] = ofs;
		kbd_buf[in_60_ofs + IN_60_PAT_OFS + 2] = ofs >> 8;

		PRINTF("pb` AhX : 0x%04x\n", in_60_ofs + IN_60_PAT_OFS);
	}

	return 1;
}

/****************************************************************************/
/*	֐															*/
/****************************************************************************/

int main(int argc, char *argv[])
{
	char ibmkbd_fname[256];
	char mykbd_fname[256];

	title();

	if (argc < 4) {
		usage();
		return 1;
	}

	/* MYKBD.SYS ̃pX */
	{
		int s;

		strcpy(mykbd_fname, argv[1]);
		s = strlen(mykbd_fname);
		if (mykbd_fname[s - 1] == '\\') mykbd_fname[s - 1] = '\0';
		strcat(mykbd_fname, "\\BOOT\\MYKBD.SYS");
		strupr(mykbd_fname);
	}

	/* IBMKBD.SYS ̃pX */
	{
		strcpy(ibmkbd_fname, argv[2]);
		strupr(ibmkbd_fname);
	}

	/* IBMKBD.SYS ǂݍ */
	{
		org_size = load_binary_file(ibmkbd_fname, kbd_buf, sizeof(kbd_buf));
		if (org_size == 0) {
			printf(
"Xy~XĂ邩AfBNgԈႦĂ邩AȂ΁A\n"
"OS/2 gp IBMKBD.SYS w肵Ă܂̂Ǝv܂B\n"
			);
			return 1;
		}
	}

	/* L[ւp̕ύXf[^ t@Cǂݍ */
	{
		int i;

		for (i = 3; i < argc; i++) {
			if (load_swap_info_file(argv[i]) == 0) {
				return 1;
			}
		}
	}

	/* ǂݍ IBMKBD.SYS ͂ */
	if (analysis() == 0) {
		printf("͎s\n");
		return 1;
	}

	if (generate() == 0) {
		printf("ύXs\n");
		return 1;
	}

	/* MYKBD.SYS ɏ */
	{
		if (save_binary_file(mykbd_fname, kbd_buf, new_size) == 0) {
			printf(
"Xy~XĂ邩AfBNgԈႦĂ邩AȂ΁A\n"
"OS/2 gp MYKBD.SYS ㏑悤ƂĂ܂̂Ǝv܂B\n"
			);
			return 1;
		}
	}

	printf(
"\n"
"%s ܂BCONFIG.SYS Ŏ̂悤ȍsTA\n"
"\n"
"  BASEDEV=IBMKBD.SYS\n"
"\n"
"̂悤ɕύXĂB\n"
"\n"
"  BASEDEV=MYKBD.SYS\n"
"\n"
"āAOS/2 n[hfBXNċNĂBŃL[\n"
"ւ͂łB\n"
	, mykbd_fname);

	return 0;
}
